#include <Arduino.h>
#include "mytime.h"


mytime::mytime() {
}

// -- pocitadlo casu na zaklade millis --
bool mytime::timeBeat(void) {
  while (millis() - _prevMillis >= 1000) {
    sysTime++;
    _prevMillis += 1000;
  }
  if (sysTime > _lastSysTime) {
    _lastSysTime = sysTime;
    _breakTime(sysTime, dt);
    if(_IsDst(dt.Day, dt.Month, dt.Wday)) {
      _breakTime(sysTime+3600, dte);
    } else {
      _breakTime(sysTime, dte);
    }
    return true;
  } else {
    return false;
  }
}

// -- konverze unixtime na datetime --
void mytime::_breakTime(uint32_t s, TE &tm) {
  uint32_t time = s;
  unsigned long days;
  uint8_t year, month, monthLength;;

  tm.Second = time % 60;
  time /= 60; // now it is minutes
  tm.Minute = time % 60;
  time /= 60; // now it is hours
  tm.Hour = time % 24;
  time /= 24; // now it is days
  tm.Wday = ((time + 4) % 7);
  year = 0;
  days = 0;
  while ((unsigned)(days += (LEAP_YEAR(year) ? 366 : 365)) <= time) {
    year++;
  }
  tm.Year = year; // year is offset from 1970

  days -= LEAP_YEAR(year) ? 366 : 365;
  time  -= days; // now it is days in this year, starting at 0

  days = 0;
  month = 0;
  monthLength = 0;
  for (month = 0; month < 12; month++) {
    if (month == 1) { // february
      if (LEAP_YEAR(year)) {
        monthLength = 29;
      } else {
        monthLength = 28;
      }
    } else {
      monthLength = monthDays[month];
    }

    if (time >= monthLength) {
      time -= monthLength;
    } else {
      break;
    }
  }
  tm.Month = month + 1;  // jan is month 1
  tm.Day = time + 1;     // day of month
}

// -- test letniho casu --
bool mytime::_IsDst(int day, int month, int dow) {
  if (month < 3 || month > 10)  return false;
  if (month > 3 && month < 10)  return true;
  int previousSunday = day - dow;
  if (month == 3) return previousSunday >= 25;
  if (month == 10) return previousSunday < 25;
  return false; // this line never gonna happend
}


