#ifndef mytime_h
#define mytime_h

#include <Arduino.h>

#define LEAP_YEAR(Y)     ( ((1970+Y)>0) && !((1970+Y)%4) && ( ((1970+Y)%100) || !((1970+Y)%400) ) )
static  const uint8_t monthDays[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}; // API starts months from 1, this array starts from 0

typedef struct  {
  uint8_t Second;
  uint8_t Minute;
  uint8_t Hour;
  uint8_t Wday;   // day of week, sunday is day 1
  uint8_t Day;
  uint8_t Month;
  uint8_t Year;   // offset from 1970;
} TE;

class mytime {

  public:
    mytime();
    bool timeBeat();
    uint32_t sysTime = 0;  // CET cas, tedy vzdy UTC+1 
    TE dt;
    TE dte;

  private:
    void _breakTime(uint32_t s, TE &tm);
    bool _IsDst(int day, int month, int dow);
    uint32_t _prevMillis = 0;
    uint32_t _lastSysTime = 0;
    bool _dstComputed = false;

};


#endif

